HTML Tidy: Memory Allocation

HTML Tidy 0.1

Data Structures | Typedefs | Functions
Memory Allocation

## Data Structures
struct | _TidyAllocatorVtbl
struct | _TidyAllocator

## Typedefs
typedef struct _TidyAllocatorVtbl | TidyAllocatorVtbl
typedef struct _TidyAllocator | TidyAllocator
typedef void *(TIDY_CALL * | TidyMalloc) (size_t len)
typedef void *(TIDY_CALL * | TidyRealloc) (void *buf, size_t len)
typedef void(TIDY_CALL * | TidyFree) (void *buf)
typedef void(TIDY_CALL * | TidyPanic) (ctmbstr mssg)

## Functions
Bool TIDY_CALL | tidySetMallocCall (TidyMalloc fmalloc)
Bool TIDY_CALL | tidySetReallocCall (TidyRealloc frealloc)
Bool TIDY_CALL | tidySetFreeCall (TidyFree ffree)
Bool TIDY_CALL | tidySetPanicCall (TidyPanic fpanic)

## Detailed Description

Tidy uses a user provided allocator for all memory allocations. If this allocator is not provided, then a default allocator is used which simply wraps standard C malloc/free calls. These wrappers call the panic function upon any failure. The default panic function prints an out of memory message to stderr, and calls exit(2).

For applications in which it is unacceptable to abort in the case of memory allocation, then the panic function can be replaced with one which longjmps() out of the tidy code. For this to clean up completely, you should be careful not to use any tidy methods that open files as these will not be closed before panic() is called.

TODO: associate file handles with tidyDoc and ensure that tidyDocRelease() can close them all.

Calling the withAllocator() family ( tidyCreateWithAllocator, tidyBufInitWithAllocator, tidyBufAllocWithAllocator) allow settings custom allocators).

All parts of the document use the same allocator. Calls that require a user provided buffer can optionally use a different allocator.

For reference in designing a plug-in allocator, most allocations made by tidy are less than 100 bytes, corresponding to attribute names/values, etc.

There is also an additional class of much larger allocations which are where most of the data from the lexer is stored. (It is not currently possible to use a separate allocator for the lexer, this would be a useful extension).

In general, approximately 1/3rd of the memory used by tidy is freed during the parse, so if memory usage is an issue then an allocator that can reuse this memory is a good idea.

## Typedef Documentation

typedef struct _TidyAllocatorVtbl TidyAllocatorVtbl

The allocators function table

typedef struct _TidyAllocator TidyAllocator

The allocator

typedef void*(TIDY_CALL * TidyMalloc) (size_t len)

Callback for "malloc" replacement

typedef void*(TIDY_CALL * TidyRealloc) (void *buf, size_t len)

Callback for "realloc" replacement

typedef void(TIDY_CALL * TidyFree) (void *buf)

Callback for "free" replacement

typedef void(TIDY_CALL * TidyPanic) (ctmbstr mssg)

Callback for "out of memory" panic state

## Function Documentation

Bool TIDY_CALL tidySetMallocCall | ( | TidyMalloc | fmalloc | ) |

Give Tidy a malloc() replacement

Bool TIDY_CALL tidySetReallocCall | ( | TidyRealloc | frealloc | ) |

Give Tidy a realloc() replacement

Bool TIDY_CALL tidySetFreeCall | ( | TidyFree | ffree | ) |

Give Tidy a free() replacement

Bool TIDY_CALL tidySetPanicCall | ( | TidyPanic | fpanic | ) |

Give Tidy an "out of memory" handler